package com.muyu.vehicle;

import com.muyu.common.ThreadPool;
import com.muyu.domain.Vehicle;
import com.muyu.vehicle.core.LocalContainer;
import com.muyu.vehicle.model.VehicleData;

import java.math.BigDecimal;
import java.util.Date;
import java.util.concurrent.CountDownLatch;

import static java.lang.Thread.sleep;

/**
 * @author DongZl
 * @description:
 * @Date 2023-11-17 上午 09:02
 */
public class Test {

    public static CountDownLatch countDownLatch = new CountDownLatch(2);
    public static void main(String[] args) throws InterruptedException {

        String vin1 = "VIN123456789123456", vin2 = "VIN123456789166666";
        init(vin1);
        init(vin2);
        new Thread(new TestThread(vin1)).start();
        new Thread(new TestThread(vin2)).start();
        countDownLatch.await();
        ThreadPool.shutdown();
    }

    public static void init(String vin){
        Vehicle vehicle = Vehicle.builder()
                .vin(vin)
                .createTime(new Date())
                .remainingBattery(new BigDecimal("45000"))
                .batteryLevel(new BigDecimal("50000"))
                .build();

        VehicleInstance vehicleInstance = new VehicleInstance();
        vehicleInstance.setVehicle(vehicle);
        vehicleInstance.setVehicleData(VehicleData.vehicleBuild(vehicle));
        LocalContainer.setVehicleInstance(vehicleInstance);
    }

}

class TestThread implements Runnable{

    private String vin ;

    public TestThread(String vin) {
        this.vin = vin;
    }

    /**
     * When an object implementing interface {@code Runnable} is used
     * to create a thread, starting the thread causes the object's
     * {@code run} method to be called in that separately executing
     * thread.
     * <p>
     * The general contract of the method {@code run} is that it may
     * take any action whatsoever.
     *
     * @see Thread#run()
     */
    @Override
    public void run() {
        VehicleInstance vehicleIns = LocalContainer.getVehicleInstance(vin);
        vehicleIns.initVehicleThread();
        try {
            sleep(3000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
        vehicleIns.startSend();

        try {
            sleep(3000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
        vehicleIns.pauseSend();

        try {
            sleep(3000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
        vehicleIns.startSend();

        try {
            sleep(3000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
        vehicleIns.stopSend();

        Test.countDownLatch.countDown();
    }
}
